#include "ModuleBaseClass.hpp"
#include <algorithm>

ModuleBaseClass::ModuleBaseClass(string className)
{
    m_module_name = className;
    //convert module name to low case
    transform(m_module_name.begin(), m_module_name.end(), m_module_name.begin(), ::tolower);

    m_command_count = 0;
    for (int i=0; i< COMMAND_NUMBER; i++)
    {
        m_command[i] = NULL;
    }
}



ModuleBaseClass::~ModuleBaseClass()
{
    int i;

    for (i =0; i<m_command_count; i++)
    {
        if (m_command[i] != NULL)
        {
            delete m_command[i];
        }
    }
}



int
ModuleBaseClass::addCommand(CommandBaseClass *point_command)
{
    if (point_command != NULL)
    {
        m_command[m_command_count] = point_command;
        m_command_count++;
    }
    
    return 0;
}



int
ModuleBaseClass::listCommand()
{
    int i, width = 15;
    string commang_str, help_str;

    cout << "Usage:	lemur " << getModuleName() << " Command" << endl;
    cout << "Command Options:" << endl;
    for (i=0; i<m_command_count; i++)
    {
    	  m_command[i]->getName(&commang_str);
    	  m_command[i]->getHelp(&help_str);
        cout << "  " << setw(width) << setiosflags(ios::left) << commang_str << help_str << endl;
    }
    
    return 0;
}



int
ModuleBaseClass::findExecuteCommand(StringParser command_line)
{
    string parser_command_name;
    int i, error = 0;
    string command_name;
    COMMAND_TYPE command_type = NO_COMMAND;
    
    command_line.getCommand(&parser_command_name);
    command_line.getCommandType(&command_type);

    //Lowcase the module name
    //command_line.convertToLowcase(m_module_name.c_str());

    if (command_type == CMD_HELP)
    {
        listCommand();
        return 0;
    }

    for (i=0; i< m_command_count; i++)
    {
    	  m_command[i]->getName(&command_name);
        if (command_name == parser_command_name)
        {
            error = m_command[i]->executeCommand(command_line);
            break;
        }
    }

    if (i == m_command_count)
    {
        cout << UNKNOWN_COMMAND_MSG << endl;
        return -2;
    }
    else
    {
        return error;
    }
}



string
ModuleBaseClass::getModuleName()
{
    return m_module_name;
}
