#ifndef ETHERNET_OPERATION_H
#define ETHERNET_OPERATION_H

#include <stdio.h>
#include <iostream>
#include <string>
#include "OperationBaseClass.hpp"
#include "EthernetDAPI.hpp"

using namespace std;


class EthernetOperation: public OperationBaseClass
{
    public:
                EthernetOperation(OPERATION_TYPE, string);
       virtual  ~EthernetOperation();

                //Decide which operation to be executed
                int  executeOperation(StringParser);

                //Operation implement here
                int  show_all(StringParser);
                int  mdi(StringParser);
                int  interrupt(StringParser);
                int  internalLoopback(StringParser);
                int  singleLoopback(StringParser);
                int  crossLoopback(StringParser);
                int  writeMAC(StringParser);
                int  readMAC(StringParser);
                int  readEEPROM(StringParser);
                int  writeEEPROM(StringParser);
                int  validateEEPROM(StringParser);
                int  programEEPROM(StringParser);
                int  readSFP(StringParser);
                int  writeSFP(StringParser);
                int  statistic(StringParser);
                int  pciError(StringParser);
                int  clear(StringParser);
                int  show_all_error(StringParser);

                //Show parameter message here
                int  Help_parameter(StringParser);

                //Check parameter syntax here
                int  Syntax_check(StringParser);
                
    private:

};

#endif
