#ifndef PSU_OPERATION_HPP
#define PSU_OPERATION_HPP

#include "OperationBaseClass.hpp"
#include "PSUDAPI.hpp"

using namespace std;

class PSUOperation: public OperationBaseClass
{
    public:
                PSUOperation(OPERATION_TYPE, string);
                PSUOperation(COMMAND_TYPE, OPERATION_TYPE, string);
        virtual ~PSUOperation();

        int     executeFANGet(StringParser);
        int     executeFANRange(StringParser);
        int     executeFANSet(StringParser);
        int     executeFWProgram(StringParser);
        int     executeLEDGet(StringParser);
        int     executeLEDSet(StringParser);
        int     executeListOperations(StringParser);
        int     executeOperation(StringParser);
        int     executeShowOperations(StringParser);
        int     executeTemperatureGet(StringParser);
        int     executeTemperatureSet(StringParser);
    private:
        void    showOperationHelp(void);

        COMMAND_TYPE    m_eCommandType;
};

#endif
