/// @file       CommonFunctions.hpp
/// @brief      Common functions for all modules
/// @details    Provide miscellaneous functions for all modules 
/// @version    1.0.0
/// @date       2014.01.21
/// @author     KenHu
/// @copyright  Copyright 2014 Hon Hai Technology Group. All Rights Reserved.

#include <string>
#include <sstream>
#include <iomanip>
#include "ErrorMsg.hpp"

#ifndef COMMON_FUNCTIONS_HPP
#define COMMON_FUNCTIONS_HPP

enum ARCH_TYPE {
    ARCH_X86 = 0,
    ARCH_ARM,
    ARCH_PPC,
};

extern void     deleteErrorMsg(ErrorMsg*    in_pErrorMsg);

extern CHAR*    trimRightChar(CHAR* in_szString, 
                              CHAR  in_chJunk);
                      
extern CHAR*    trimLeftChar(CHAR* in_szString, 
                             CHAR  in_chJunk);

extern void     getErrorMessage(ErrorMsg*   in_pErrorMsgList, 
                                string*     out_strpMessage);
                                
extern void     getLastErrorMessage(ErrorMsg*   in_pErrorMsgList, 
                                    string*     out_strpMessage);

extern string   Int2HexStr(UINT32 i, UINT8 digits = 2);

extern string   Int2Str(INT32 i);

extern string   UINT64ToHexStr(UINT64 in_u64Value);

extern string   BCDToStr(UINT8 in_u8BCDValue);

extern ARCH_TYPE    getArch(void);

extern void ConvertCharToUpperCase(CHAR* userCharacter);
extern void ConvertStringToUpperCase(CHAR* userString);
extern void ConvertCharToLowerCase(CHAR* userCharacter);
extern void ConvertStringLowerCase(CHAR* userString);

#endif
