/// @file       BaseClassDAPI.hpp
/// @brief      BaseClassDAPI class
/// @details    Provide DAPI base class for all modules
/// @copyright  Copyright 2014 Hon Hai Technology Group. All Rights Reserved.

#ifndef BASE_CLASS_DAPI_HPP
#define BASE_CLASS_DAPI_HPP

#include "BaseClassAPI.hpp"
//#include "XML_Structure.hpp"


/// @class      BaseClassDAPI BaseClassDAPI.hpp "BaseClassDAPI.hpp"
/// @brief      Provide DAPI common functions for all modules 
/// @param      m_u64TotalStep is a 64bits value for amount of total steps for computing DAPI's progress
/// @param      m_u64StepCount is a 64bits value for amount of finished steps for computing DAPI's progress
class BaseClassDAPI : public BaseClassAPI
{
    public:
                            BaseClassDAPI(STRING in_szClassName);
                                                  
        virtual             ~BaseClassDAPI(void);

        INT32               getProgress(void);

    protected:
        void                displayDebugLoopMessage(INT32   in_s32MessageLevel, 
                                                    INT32   in_s32LoopCount, 
                                                    INT32   in_s32MaxLoopCount);
        void                displayDebugString(INT32    in_s32MessageLevel, 
                                               STRING   in_szMessageString, 
                                               BOOL     in_bDisplayClassNamePrefix = TRUE);
        
        void                initProgress(UINT64 in_u64TotalStep);

        void                updateProgress(UINT64 in_u64FinishedStep);
        
    private:
        UINT64              m_u64TotalStep;
        UINT64              m_u64StepCount;
};

#endif

