#ifndef GetMCEDAPI_H
#define GetMCEDAPI_H

#include "error_code.hpp"
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include "BaseClassDAPI.hpp"

/*typedef unsigned long long u64;
typedef unsigned int       u32;
typedef unsigned short     u16;
typedef unsigned char       u8;

#define __u64 u64
#define __u32 u32
#define __u16 u16
#define __u8  u8
*/

struct mcefd_data {
    unsigned loglen;
    unsigned recordlen;
    char     *buf;
};

struct mce {
    unsigned long long status;
    unsigned long long misc;
    unsigned long long addr;
    unsigned long long mcgstatus;
    unsigned long long ip;
    unsigned long long tsc;       /* cpu time stamp counter */
    unsigned long long time;      /* wall time_t when error was detected */
    unsigned char      cpuvendor; /* cpu vendor as encoded in system.h */
    unsigned char      pad1;
    unsigned short     pad2;
    unsigned int       cpuid;     /* CPUID 1 EAX */
    unsigned char      cs;        /* code segment */
    unsigned char      bank;      /* machine check bank */
    unsigned char      cpu;       /* cpu number; obsolete; use extcpu now */
    unsigned char      finished;  /* entry is valid */
    unsigned int       extcpu;    /* linux cpu number that detected the error */
    unsigned int       socketid;  /* CPU socket ID */
    unsigned int       apicid;    /* CPU initial apic ID */
    unsigned long long mcgcap;    /* MCGCAP MSR: machine check capabilities of CPU */
};

//static int ret = 0;

#define MCE_GET_RECORD_LEN   _IOR('M', 1, int)
#define MCE_GET_LOG_LEN      _IOR('M', 2, int)
#define MCE_GETCLEAR_FLAGS   _IOR('M', 3, int)


class GetMCEDAPI : public BaseClassDAPI
{
public:
                            GetMCEDAPI(STRING className);
                 virtual    ~GetMCEDAPI(void);
                 ErrorMsg*  Execute(string *Test_result);
                 ErrorMsg*  Execute(int CPU_socketID, string *MCE_message);

protected:

private:
                 void       mce_prepare(struct mce *m);
                 void       dump_mce_raw_ascii(struct mce *m, unsigned recordlen, string *Test_result);
                 void       dump_mce_raw_ascii(struct mce *m, unsigned recordlen, string *MCE_message, int CPU_socketID);
                 ErrorMsg*  process(int fd, unsigned recordlen, unsigned loglen, char *buf, string *Test_result);
                 ErrorMsg*  process(int fd, unsigned recordlen, unsigned loglen, char *buf, string *MCE_message, int CPU_socketID);

                 struct     mcefd_data d;
                 int        opt;
                 int        fd;
                 ErrorMsg*  m_ErrorMsg;

};

#endif
