#ifndef CPU_DAPI_H
#define CPU_DAPI_H

#include "BaseClassDAPI.hpp"
#include "ProcessorDDAPI.hpp"
#include "StabilityTest.hpp"
#include "GetMCEDAPI.hpp"
#include <sched.h>

enum CPU_ITEM
{
   CPU_ITEM_ALL,
   CPU_ITEM_CPU,
   CPU_ITEM_VENDOR,
   CPU_ITEM_MODEL,
   CPU_ITEM_FAMILY,
   CPU_ITEM_CORE,
   CPU_ITEM_FREQUENCY,
   CPU_ITEM_STEPPING,
   CPU_ITEM_CACHE,
   CPU_ITEM_TEMPERATURE
};


class ProcessorDAPI : public BaseClassDAPI
{
    public:
                        ProcessorDAPI(STRING className);
    virtual             ~ProcessorDAPI(void);
          ErrorMsg*     Get_CPU_number(int *CPU_count);
          ErrorMsg*     Get_CPU_physical_number(int *CPU_count);
//          ErrorMsg*     GetInformation(XML_CPU* CPU_data);
          ErrorMsg*     GetInformation(string WellKnownName, CPU_ITEM option, string *result);
          ErrorMsg*     StabilityTest(INT32 *Test_result, int display, int loop);
          ErrorMsg*     GetErrorRegisters(INT32  *Test_result);
          ErrorMsg*     GetMCE(string *Test_result);
          ErrorMsg*     GetMCE(string wellKnownName, string *MCE_message);
          ErrorMsg*     GetCPUIDByWellKnowName(string wellKnownName, int *ID);
          ErrorMsg*     SetExecutionCPUCore(string wellKnownName);
          ErrorMsg*     Read(string wellKnownName, int CPU_register, int count, list<unsigned long long> *val);
          ErrorMsg*     Write(string wellKnownName, int CPU_register, unsigned long long Data);

    protected:

    private:
          ProcessorDDAPI*    m_cpuDriver;
//          XML_CPU*           m_xml_CPU;
          ErrorMsg*          m_ErrorMsg;
};

#endif

