#include "GPIODAPI.hpp"

GPIODAPI::GPIODAPI(STRING className) : BaseClassDAPI(className)
{
	ErrorMsg *pErrorMsg = NO_ERROR_MSG;

    //m_errorCode =  getErrorMsg();
    //if (m_errorCode != NO_ERROR_MSG)
    //{
    //    addErrorMsg(ERROR_GPIO_DAPI_CONSTRUCTOR, NULL, m_errorCode);
    //}

    if ((m_GPIODiver = new GPIODDAPI("GPIO_drv")) == NULL)
    {
    	addErrorMsg( (ERRORCODE)(ERROR_GPIO_DAPI_CONSTRUCTOR | ERROR_DIAGNOSTIC_API_CONSTRUCTOR1_ERROR), "Create GPIO_DDAPI fail");
    	return;
    }

	if((pErrorMsg=m_GPIODiver->getErrorMsg()) != NO_ERROR_MSG)
	{
		addErrorMsg(ERROR_GPIO_DAPI_CONSTRUCTOR, NULL, pErrorMsg);
		return;
	}


   
}

GPIODAPI::~GPIODAPI()
{

    if (m_GPIODiver != NULL)
        delete m_GPIODiver;

}


ErrorMsg * GPIODAPI::displayGPIOList(list<string> *pGPIOList)
{
    //printf("%s\n", __func__);
	ErrorMsg*   pErrorMsg = NO_ERROR_MSG;

	pErrorMsg = m_GPIODiver->getGPIOList(pGPIOList);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_GPIO_DAPI_DISPLAY_GPIO_LIST, NULL, pErrorMsg);
    }

    return NO_ERROR_MSG;

}


ErrorMsg*   GPIODAPI::getStatus(string  name, BOOL* pGPIOStatus)
{
    //printf("%s\n", __PRETTY_FUNCTION__);

    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;


    pErrorMsg = m_GPIODiver->readBit(name, pGPIOStatus);
    if (pErrorMsg != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_GPIO_DAPI_GPIO_GET_STATUS, NULL, pErrorMsg);
    }

    return NO_ERROR_MSG;
}
ErrorMsg*   GPIODAPI::setStatus(string  name, BOOL Status)
{
    //printf("%s\n", __PRETTY_FUNCTION__);

    ErrorMsg*   ErrorMsg = NO_ERROR_MSG;

    //if (setON == TRUE)
    ErrorMsg = m_GPIODiver->writeBit(name, Status);
    if (ErrorMsg != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_GPIO_DAPI_GPIO_SET_STATUS, NULL, ErrorMsg);
    }


    return NO_ERROR_MSG;
}

