#ifndef I2C_DAPI_H
#define I2C_DAPI_H

#include "BaseClassDAPI.hpp"
#include "I2CDDAPI.hpp"


class I2CDAPI : public BaseClassDAPI
{
    public: 
                         I2CDAPI(STRING className);
            virtual      ~I2CDAPI(void);
            ErrorMsg  *  DisplayI2cDevicesList(list<string> *i2c_list);
            ErrorMsg  *  Read(string well_know_name, int StartRegister, int EndRegister, int *data, int *count);
            ErrorMsg  *  Read(string well_know_name, int StartRegister, int EndRegister, UINT8 *data, int *count);
            ErrorMsg  *  Read(string well_know_name, int StartRegister, int EndRegister, UINT16 *data, int *count);
            ErrorMsg  *  Read(int bus, int deviceAddress, int StartRegister, int EndRegister, int *data, int *count);
            ErrorMsg  *  Read(int bus, int deviceAddress, int StartRegister, int EndRegister, UINT8 *data, int *count);
            ErrorMsg  *  Read(int bus, int deviceAddress, int StartRegister, int EndRegister, UINT16 *data, int *count);
            ErrorMsg  *  Write(string well_know_name, int StartRegister, int *data, int count);
            ErrorMsg  *  Write(string well_know_name, int StartRegister, int *data, int count, int *numberRealWrite);
            ErrorMsg  *  Write(string well_know_name, int StartRegister, UINT8 *data, int count);
            ErrorMsg  *  Write(string well_know_name, int StartRegister, UINT16 *data, int count);
            ErrorMsg  *  Write(int bus, int deviceAddress, int StartRegister, int *data, int count);
            ErrorMsg  *  Write(int bus, int deviceAddress, int StartRegister, int *data, int count, int *numberRealWrite);
            ErrorMsg  *  Write(int bus, int deviceAddress, int StartRegister, UINT8 *data, int count);
            ErrorMsg  *  Write(int bus, int deviceAddress, int StartRegister, UINT16 *data, int count);
            ErrorMsg  *  DisplayI2cDevicesListByType(I2CDevice *i2c_list[], I2C_DEVICE_TYPE type);
            ErrorMsg  *  DisplayI2cDevicesList(I2CDevice *i2c_list[], int *count);
            ErrorMsg  *  MUX_Test(string well_know_name);
            ErrorMsg  *  StuckPrevention(int busID);
            ErrorMsg  *  WriteReadTest(string well_know_name);
            ErrorMsg  *  DisplayBufferContent(int *buffer, int count);
            ErrorMsg  *  ShowRoutePath(string well_know_name, string *path);

    protected:

    private:
            I2CDDAPI    *m_i2c_driver;
            ErrorMsg    *m_errorCode;

};

#endif
