#ifndef INTEL_X552_H
#define INTEL_X552_H

#include "EthernetBaseClass.hpp"
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>

#define MDIO_READ     0x08000000
#define MDIO_WRITE    0x04000000

//Mask define
#define MDIO_READY    0x10000000
#define MDIO_IE       0x20000000
#define MDIO_ERR      0x40000000

#define PHY_REG_NUM   0x1F
#define PHY_DATA_LEN  0x0FFFF
#define MDIO_CONTROL_REGISTER  0x20


class INTEL_X552 : public EthernetBaseClass
{
    public:
                  INTEL_X552(STRING);
                  ~INTEL_X552();
        ErrorMsg* Set_external_loopback();
        ErrorMsg* Remove_external_loopback();
        ErrorMsg* Get_self_test_result(struct ethtool_test *test, TestType index, INT32 *test_result);
        ErrorMsg* SetupSpeed(string ethernet_name, INT32 speed);
        ErrorMsg* GetMAC(string ethernet_name, string *mac_address);
        ErrorMsg* SetMAC(string ethernet_name, string *mac_address);
        ErrorMsg* GetEEPROM(string ethernet_name, INT32 StartAddress, INT32 Length, INT32 *data);
        ErrorMsg* SetEEPROM(string ethernet_name, INT32 StartAddress, INT32 *data, INT32 Length);
        ErrorMsg* ReadSFP(string ethernet_name, INT32 DeviceAddress, INT32 StartAddress, INT32 Length, INT32 *data);
             int  read_PHY_reg(int reg, int page);
             int  write_PHY_reg(int reg, int page , int data);

    protected:

    private:
        unsigned int *MDIO_point;
};

#endif

