#ifndef EXPANDER_DDAPI_H
#define EXPANDER_DDAPI_H

#include "BaseClassDDAPI.hpp"
#include <iostream>
#include <list>
#include <cctype>

using namespace std ;

#define EXPANDER_DEVICE_NAME_LENGTH     20
#define MAX_EXP_DATAELEMENT_NUM			EXP_DATAELEMENT_ADDRESS //Not include EXP_DATAELEMENT_ALL
#define MAX_EXP_ERRORELEMENT_NUM		EXP_ERRORELEMENT_PHY_RESET_PRBM //Not include EXP_ERRORELEMENT_ALL_ERROR


typedef enum {
    
    EXP_CONTROLLER = 0,
    EXP_PORT,
    EXP_PHY,
    
} EXP_DEVICE;

typedef enum {
    EXP_DATAELEMENT_ATTACHED_TYPE = 0,
    EXP_DATAELEMENT_LINK,
    EXP_DATAELEMENT_SPEED,
    EXP_DATAELEMENT_ADDRESS,
    EXP_DATAELEMENT_ALL,
    
} EXP_DATAELEMENT;

typedef enum {
    
    EXP_ERRORELEMENT_DISPARITY_ERR = 0,
    EXP_ERRORELEMENT_INVALID_DWORD_ERR,
    EXP_ERRORELEMENT_LOSS_DWORD_SYNC,
    EXP_ERRORELEMENT_PHY_RESET_PRBM,
    EXP_ERRORELEMENT_ALL_ERROR,
    
} EXP_ERRORELEMENT;

class ExpanderDDAPI : public BaseClassDDAPI
{
public:
                        ExpanderDDAPI(STRING className);
                        ~ExpanderDDAPI(void);
        void            getDeviceNameByID(EXP_DEVICE devType, UINT32 index, string *strWellKnownName);
        ErrorMsg*       getLogicalIDByName(string wellKnownName, UINT32 *logicalID);
        ErrorMsg*       getDataByID(UINT32 logicalID, EXP_DATAELEMENT dataElement, string *strReturnData);
        ErrorMsg*       reset(UINT32 logicalID);
        ErrorMsg*       getErrorDataByID(UINT32 logicalID, EXP_ERRORELEMENT dataElement, string *strReturnData);
        ErrorMsg*       clearPHYError();

protected:


private:
        struct ExpanderDeviceConfig{
                UINT32              logicalID;
                CHAR                wellKnownName[EXPANDER_DEVICE_NAME_LENGTH + 1];
                CHAR                deviceName[EXPANDER_DEVICE_NAME_LENGTH + 1];	// plus one for the NULL termination
                EXP_DEVICE          devType;};
                
        typedef struct ExpanderDeviceConfig EXP_DEV_CONFIG;
        
        list<EXP_DEV_CONFIG>        m_expDevice;
        char                        m_tmpString[100];
        
        bool            compareStrNum (const EXP_DEV_CONFIG &first, const EXP_DEV_CONFIG &second);
        string          convertStringToUpperCase(string strInputString);
};

#endif

