/*
 * GPIOGeneric.hpp
 *
 *  Created on: Dec 2, 2015
 *      Author: ianfang
 */

#ifndef GPIO_FPGADRIVER_HPP
#define GPIO_FPGADRIVER_HPP
#include "GPIOGeneric.hpp"
#include "PCIDDAPI.hpp"
#include "MemoryDDAPI.hpp"

#define MAX_FPGA_GPIO_CONFIG_ENTRIES    200
#define GPIO_NOT_FOUND                  10000

class GPIO_FPGADriver : public GPIOGeneric
{
    public:
            GPIO_FPGADriver(STRING className);
            ~GPIO_FPGADriver();


        ErrorMsg*   AddEntry(STRING dataElementName,

        		FPGA_DRIVER_DATA_TYPE dataElementType,
                             GPIO_RW_MODE gpioRWMode,
                             UINT32 offset,
                             UINT8 msbLocation,
                             UINT8 lsbLocation,
                             BOOL bitState,
                             BOOL disableWriteProtect = TRUE);
         ErrorMsg*  readINIFile(CHAR *Line);

         ErrorMsg*  getGPIOList(list<string> *pGPIOList);
         ErrorMsg*  readBit(string gpioName, BOOL*  readValue);
         ErrorMsg*  isMyGPIO(string    gpioName);
         ErrorMsg*   setBit(string  gpioName, BOOL Status);
//        virtual ERRORCODE AddEntry(STRING gpioName,
//                                   UINT32 gpioIndex,
//                                   UINT32 bWritable
//                                   );
//        virtual ERRORCODE GetWellKnownNameByIndex(INT32 index, CHAR* gpioName, INT32 stringLength);
//        virtual ERRORCODE IsMyGPIO(STRING gpioName);
//        virtual ERRORCODE ReadBit(STRING gpioName, BOOL* readValue);
//        virtual ERRORCODE ResetBit(STRING gpioName);
//        virtual ERRORCODE SetBit(STRING gpioName);

    protected:

    private:
         struct FpgaGPIOConfiguration{
                            CHAR                    dataElementName[(FPGA_DATA_ELEMENT_NAME_LENGTH + 10)];
                            FPGA_DRIVER_DATA_TYPE   dataElementType;
                            GPIO_RW_MODE            gpioRWMode;
                            UINT32                  offset;
                            UINT8                   msbLocation;
                            UINT8                   lsbLocation;
                            BOOL                    bitState;
                            BOOL                    disableWriteProtect;
                    };
                    typedef struct FpgaGPIOConfiguration FPGA_GPIO_CONFIGURATION;

                    UINT32                  m_BaseAddressRegister;
                    ErrorMsg                *m_errorCode;
                    INT32                   m_ConfigurationTableIndex;
                    PCIDDAPI                *m_PCIDriver;
                    MemoryDDAPI             *m_MemoryDriver;
                    FPGA_GPIO_CONFIGURATION m_gpioConfiguration[MAX_FPGA_GPIO_CONFIG_ENTRIES];

                    UINT32 GetGPIOIndexByName(string gpioName);



};





#endif /* GPIO_FPGADRIVER_HPP */
