/// @file       FXNMCDrvIOCTL.h
/// @brief      Provide definitions for IOCTL commands supported by Foxconn memory controller driver  
/// @details    Provide low layer diagnostic and utility APIs for memory module
/// @author     KenHu
/// @copyright  Copyright 2014 Hon Hai Technology Group. All Rights Reserved.

#ifndef FXN_MC_DRV_IOCTL_H
#define FXN_MC_DRV_IOCTL_H

#include <asm/ioctl.h>
#include <sys/ioctl.h>

#include "FXNMCDrv.h"

extern CHAR g_szMCDrvIOCTLResult[];


#define GET_CORRECTED_ECC_COUNT_IOCTL_COMMAND \
            _IOR(FXN_MC_DRV_MAGIC_NUMBER, GET_CORRECTED_ECC_COUNT_CMD_CODE, g_szMCDrvIOCTLResult)

#define GET_UNCORRECTED_ECC_COUNT_IOCTL_COMMAND \
            _IOR(FXN_MC_DRV_MAGIC_NUMBER, GET_UNCORRECTED_ECC_COUNT_CMD_CODE, g_szMCDrvIOCTLResult)

#define CLEAR_CORRECTED_ECC_STATUS_IOCTL_COMMAND \
            _IO(FXN_MC_DRV_MAGIC_NUMBER, CLEAR_CORRECTED_ECC_STATUS_CMD_CODE)

#define CLEAR_UNCORRECTED_ECC_STATUS_IOCTL_COMMAND \
            _IO(FXN_MC_DRV_MAGIC_NUMBER, CLEAR_UNCORRECTED_ECC_STATUS_CMD_CODE)

#endif
