/// @file       SASIOCTL.hpp
/// @brief      SASIOCTL class definition
/// @details    Provide SAS IOCTL class member and function definition
/// @version    1.0.0
/// @date       2014.02.25
/// @author     JerryLee
/// @copyright  Copyright 2014 Hon Hai Technology Group. All Rights Reserved.

#ifndef SASIOCTL_HPP_
#define SASIOCTL_HPP_

#include "IOCTL.hpp"
#include "common.hpp"
#include "diag_ioctl.hpp"

class SASIOCTL: public IOCTL
{
    public:
        SASIOCTL(STRING in_fileName);
        virtual ~SASIOCTL(void);

        enum IOCTL_OP_CODE
        {   UnspportIOCTLCommand = IOCTL::UnspportIOCTL,
            CLEAR_ERR_LOG,
            CLEAR_ERR_LOG_BY_PHY,
            EXECUTE_LOOPBACK,
            EXECUTE_IOC_SMP,
            EXECUTE_IOC_HARD_RESET,
            SHOW_ATTACHED_DEVICE,
            CURRENT_TEMP,
            IOC_INFORMATION,
            ERROR_STATISTICS,
            PHY_ERROR_COUNT,
            LINK_STATUS,
            LINK_SPEED,
            IOC_SAS_ADDRESS,
            PHY_SAS_ADDRESS,
        };

        ERRORCODE allocateIOCTLArgument(UINT8 IOCTLOperation);
        ERRORCODE setIOCTLOperationArgument(UINT8 IOCTLOperation, void* data = NULL);
        ERRORCODE executeIOCTL(UINT8 IOCTLOperation);
        ERRORCODE executeIOCTL(UINT8 IOCTLOperation, void* out_pIOCTLResult);

        protected:

        private:

    };

#endif /* SASIOCTL_HPP_ */
